/***************************************************************************
    FIXES  var handling bugs
    Copyright (C) 2003 - 2004 by Thomas Hasart
    thasart@gmx.de
    
    Copyright (C) 2002 by Jakob Simon-Gaarde
    jsgaarde@tdcspace.dk
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
 ***************************************************************************/

#ifndef FILEPROPERTYDLG_H
#define FILEPROPERTYDLG_H

#include "trollprojectwidget.h"
#include "filepropertybase.h"
#include "trollprojectitem.h"

class QCheckListItem;
class QListViewItem;
class FilePropertyBase;
class FileItem;
class GroupItem;

//------------------------------------------------------------------------------------------------------------------------------------------
class ScopeItem : public QCheckListItem
{
	public:
		ScopeItem(QCheckListItem *parent,const QString& aKey,const QString& aFile,TrollProjectItem* aItem);
		ScopeItem(QListView *parent,const QString& aKey,const QString& aFile,TrollProjectItem* aItem);
	QString        getScopeString() {return myItem?myItem->scopeString:"";}
		//void            setScopeString(const QString &scopeString) {m_scopeString = scopeString;}
		void            excludeFromScope(const QString &fileName,bool b);
		bool            isDirty();
		void apply();

	private:
		TrollProjectItem *myItem;
		QString myKey;
		QString myFileName;
};

//------------------------------------------------------------------------------------------------------------------------------------------
class FilePropertyDlg : public FilePropertyBase
{
	public:
		FilePropertyDlg(TrollProjectItem *spitem, int grtype,FileItem *fitem,  QWidget *parent=0,
		                const char* name = 0,bool modal = FALSE, WFlags fl = 0);

	private:
		void            createScopeTree(TrollProjectItem *spitem,ScopeItem *sitem=0);
		GroupItem*      getInstallRoot(TrollProjectItem *spitem);
		GroupItem*      getInstallObject(TrollProjectItem *spitem,const QString& objectname);
		QString	    getKey();
		void     applyExcludedScopes(ScopeItem *sitem=0);
		FileItem        *myFileItem;
		TrollProjectItem  *myProjectItem;
		QString         m_installObjectName;
		int             m_gtype;

	public slots:
		virtual void updateFileProperties();
};

#endif
