/***************************************************************************
 *   Copyright (C) 2004 by Thomas Hasart
 *   thasart@gmx.de
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version
 *
 ***************************************************************************/


#include "tpconfigbasicpage.h"
#include "trollprojectconfig.h"
#include "tpconfigdialog.h"

#include <qradiobutton.h>
#include <qcheckbox.h>
#include <klineedit.h>
#include <kurlrequester.h>

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigBasicPage::TPConfigBasicPage(TPConfigDialog *aDlg,QWidget* parent, const char* name, WFlags fl)
		: TPConfigBasicPageBase(parent,name,fl)
{
	myDialog=aDlg;
	slotUpdateControls();
}

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigBasicPage::~TPConfigBasicPage()
{}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigBasicPage::slotUpdateControls( )
{
	// Project template
	switch (myDialog->project()->configuration.m_template)
	{
		case QTMP_APPLICATION:
		myTemplAppRadio->setChecked(true);
		break;
		case QTMP_LIBRARY:
		myTemplLibRadio->setChecked(true);
		break;
		case QTMP_SUBDIRS:
		myTemplSubdirsRadio->setChecked(true);
		break;
	}

	myMakefileUrlEdit->setURL(myDialog->project()->configuration.m_makefile);
	myInstallCheck->setChecked(myDialog->project()->configuration.m_target_install);
	myInstallPathEdit->setEnabled(myDialog->project()->configuration.m_target_install);
	myInstallPathEdit->setText(myDialog->project()->configuration.m_target_install_path);
	myTargetFileEdit->setText(myDialog->project()->configuration.m_target);
	myTargetPathEdit->setText(myDialog->project()->configuration.m_destdir);
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigBasicPage::applyToConfig( )
{
	// Project template
	if(myTemplAppRadio->isChecked())myDialog->project()->configuration.m_template=QTMP_APPLICATION;
	else if(myTemplLibRadio->isChecked())myDialog->project()->configuration.m_template=QTMP_LIBRARY;
	else if(myTemplSubdirsRadio->isChecked())myDialog->project()->configuration.m_template=QTMP_SUBDIRS;

	myDialog->project()->configuration.m_makefile=myMakefileUrlEdit->url();
	myDialog->project()->configuration.m_target_install=myInstallCheck->isChecked();
	myDialog->project()->configuration.m_target_install_path=myInstallPathEdit->text();
	myDialog->project()->configuration.m_target=myTargetFileEdit->text();
	myDialog->project()->configuration.m_destdir=myTargetPathEdit->text();
}

/*$SPECIALIZATION$*/


#include "tpconfigbasicpage.moc"

