/***************************************************************************
 *   Copyright (C) 2004 by Thomas Hasart
 *   thasart@gmx.de
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version
 *
 ***************************************************************************/


#include "tpconfigbuildmodepage.h"
#include "trollprojectconfig.h"
#include "tpconfigdialog.h"

#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <klineedit.h>

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigBuildModePage::TPConfigBuildModePage( TPConfigDialog *aDlg, QWidget * parent, const char * name, WFlags fl )
		: TPConfigBuildModePageBase(parent,name,fl)
{
	myDialog=aDlg;
	slotUpdateControls();
	//connect(myConf,SIGNAL(applyToConfig()),this,SLOT(applyToConfig()));
}

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigBuildModePage::~TPConfigBuildModePage()
{}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigBuildModePage::slotUpdateControls()
{
	myLibGroup->setEnabled(false);
	if(myDialog->project()->configuration.m_template==QTMP_LIBRARY)
	{
		myLibGroup->setEnabled(true);
		if (myDialog->project()->configuration.m_requirements & QD_STATIC)	myStaticRadio->setChecked(true);
		else if (myDialog->project()->configuration.m_requirements & QD_SHARED)	mySharedRadio->setChecked(true);
		else if (myDialog->project()->configuration.m_requirements & QD_PLUGIN)		myPluginRadio->setChecked(true);
	}
	myLibVersionEdit->setText(myDialog->project()->configuration.m_libraryversion);

	// Buildmode
	if (myDialog->project()->configuration.m_buildMode== QBM_DEBUG)		myDebugRadio->setChecked(true);
	else if(myDialog->project()->configuration.m_buildMode== QBM_RELEASE)	myReleaseRadio->setChecked(true);

	// Requirements
	if (myDialog->project()->configuration.m_requirements & QD_QT)		myQtCheck->setChecked(true);
	if (myDialog->project()->configuration.m_requirements & QD_OPENGL)	myOpenGLCheck->setChecked(true);
	if (myDialog->project()->configuration.m_requirements & QD_THREAD)	myThreadCheck->setChecked(true);
	if (myDialog->project()->configuration.m_requirements & QD_X11)		myX11Check->setChecked(true);
	if (myDialog->project()->configuration.m_requirements & QD_ORDERED)	myOrderedCheck->setChecked(true);
	if (myDialog->project()->configuration.m_requirements & QD_EXCEPTIONS)	myExceptionCheck->setChecked(true);
	if (myDialog->project()->configuration.m_requirements & QD_STL)		myStlCheck->setChecked(true);
	if (myDialog->project()->configuration.m_requirements & QD_RTTI)		myRttiCheck->setChecked(true);
	if (myDialog->project()->configuration.m_requirements & QD_PCH)		myPchCheck->setChecked(true);

	// Warnings
	if (myDialog->project()->configuration.m_warnings == QWARN_ON)   myWarningCheck->setChecked(true);
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigBuildModePage::applyToConfig( )
{
	myDialog->project()->configuration.m_requirements=0;
	
	if(myLibGroup->isEnabled())
	{
		myLibGroup->setEnabled(true);
		if(myStaticRadio->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements | QD_STATIC;
		else if(mySharedRadio->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements | QD_SHARED;
		else if(myPluginRadio->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements | QD_PLUGIN;
	}
	myDialog->project()->configuration.m_libraryversion=myLibVersionEdit->text();

	// Buildmode
	if(myDebugRadio->isChecked()) myDialog->project()->configuration.m_buildMode=QBM_DEBUG;
	else if(myReleaseRadio->isChecked()) myDialog->project()->configuration.m_buildMode=QBM_RELEASE;

	// Requirements
	if (myQtCheck->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_QT;
	if (myOpenGLCheck->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_OPENGL;
	if (myThreadCheck->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_THREAD;
	if (myX11Check->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_X11;
	if (myOrderedCheck->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_ORDERED;
	if (myExceptionCheck->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_EXCEPTIONS;
	if (myStlCheck->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_STL;
	if (myRttiCheck->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_RTTI;
	if (myPchCheck->isChecked()) myDialog->project()->configuration.m_requirements=myDialog->project()->configuration.m_requirements| QD_PCH;
	
	myDialog->project()->configuration.m_warnings = QWARN_OFF;
	if(myWarningCheck->isChecked())myDialog->project()->configuration.m_warnings = QWARN_ON;
	
	slotUpdateControls();
}


/*$SPECIALIZATION$*/


#include "tpconfigbuildmodepage.moc"

