/***************************************************************************
 *   Copyright (C) 2004 by Thomas Hasart
 *   thasart@gmx.de
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version
 *
 ***************************************************************************/


#include "tpconfigbuildorderpage.h"
#include "tpconfigdialog.h"

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigBuildOrderPage::TPConfigBuildOrderPage( TPConfigDialog *aDlg, QWidget * parent, const char * name, WFlags fl )
		: TPInsideListView(parent,name,fl)
{
	//delete(myInsideLayout);
	myDialog=aDlg;
	slotUpdateControls();
	//connect(myConf,SIGNAL(applyToConfig()),this,SLOT(applyToConfig()));

}

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigBuildOrderPage::~TPConfigBuildOrderPage()
{
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigBuildOrderPage::slotUpdateControls( )
{
	//sort build order only if subdirs
	listView()->clear();

	if(myDialog->project()->configuration.m_template==QTMP_SUBDIRS)
	{
		setEnabled(true);
		QPtrList <TrollBaseItem> itemList;

		TrollBaseItem *item=(TrollBaseItem *)myDialog->project()->firstChild();
		while(item)
		{
			itemList.append(item);
			item=(TrollBaseItem*)item->nextSibling();
		}



		//incaddTab->setEnabled(false);
		listView()->setSorting(-1,false);
		QStringList buildList=myDialog->project()->configuration.subdirs();
		QStringList::Iterator it1=buildList.begin();
		for(;it1!=buildList.end();++it1)
		{
			item=itemList.first();
			while(item)
			{
				if(item->type()==TrollBaseItem::Subproject)
				{
					if(item->text(0)==(*it1))
					{
						new QListViewItem(listView(),listView()->lastItem(),item->text(0));
						itemList.take();
						item=itemList.first();
					}
				}
				item=itemList.next();;
			}
		}
		//add the rest
		item=itemList.first();
		while(item)
		{
			if(item->type()==TrollBaseItem::Subproject)
			{
				new QListViewItem(listView(),listView()->lastItem(),item->text(0));
			}
			item=itemList.next();;
		}

	}
	else setEnabled(false);

}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigBuildOrderPage::slotOutsideEdit( )
{
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigBuildOrderPage::slotOutsideAdd( )
{
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigBuildOrderPage::applyToConfig( )
{
	//change build order
	QListViewItem* lvItem=listView()->firstChild();
	QStringList tList;
	while(lvItem)
	{
		tList.append(lvItem->text(0));
		lvItem=lvItem->itemBelow();
	}
	myDialog->project()->configuration.setSubdirs(tList);
	

}

/*$SPECIALIZATION$*/


#include "tpconfigbuildorderpage.moc"

