/***************************************************************************
 *   Copyright (C) 2004 by Thomas Hasart
 *   thasart@gmx.de
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version
 *
 ***************************************************************************/


#include "tpconfigcompilerpage.h"
#include <klineedit.h>
#include "tpconfigdialog.h"

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigCompilerPage::TPConfigCompilerPage( TPConfigDialog *aDlg, QWidget * parent, const char * name, WFlags fl )
		: TPConfigCompilerPageBase(parent,name,fl)
{
	//delete(myInsideLayout);
	myDialog=aDlg;
	slotUpdateControls();
	//connect(myConf,SIGNAL(applyToConfig()),this,SLOT(applyToConfig()));
}

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigCompilerPage::~TPConfigCompilerPage()
{
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigCompilerPage::slotUpdateControls( )
{
	myDefinesEdit->setText(myDialog->project()->configuration.m_defines.join(" "));
	myDebugFlagsEdit->setText(myDialog->project()->configuration.m_cxxflags_debug.join(" "));
	myReleaseFlagsEdit->setText(myDialog->project()->configuration.m_cxxflags_release.join(" "));
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigCompilerPage::applyToConfig( )
{
	myDialog->project()->configuration.m_defines=QStringList::split(" ",myDefinesEdit->text());
	myDialog->project()->configuration.m_cxxflags_debug=QStringList::split(" ",myDebugFlagsEdit->text());
	myDialog->project()->configuration.m_cxxflags_release=QStringList::split(" ",myReleaseFlagsEdit->text());
}

/*$SPECIALIZATION$*/


#include "tpconfigcompilerpage.moc"

