/***************************************************************************
 *   Copyright (C) 2004 by Thomas Hasart
 *   thasart@gmx.de
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version
 *
 ***************************************************************************/

#ifndef TPCONFIGDIALOG_H
#define TPCONFIGDIALOG_H

#include <kdialogbase.h>

class TPConfigBasicPage;
class TPConfigBuildModePage;
class TPConfigIncludePage;
class TPConfigLibsPage;
class TPConfigLibPathsPage;
class TPConfigDepsPage;
class TPConfigBuildOrderPage;
class TPConfigCompilerPage;
class TPConfigLocationsPage;
class TPConfigCorbaPage;

class TrollProjectItem;

class SubqmakeprojectItem;
class QListView;
/**
@author KDevelop Authors
*/
class TPConfigDialog : public KDialogBase
{
		Q_OBJECT
	public:
		TPConfigDialog(TrollProjectItem* aPrj,QWidget *parent = 0, const char *name = 0,bool modal=true);
		~TPConfigDialog();
		TrollProjectItem* project();
		void setProject(TrollProjectItem* aPrj);

	private:
		void setupBasicPage();
		void setupBuildModePage();
		void setupIncludePage();
		void setupLibsPage();
		void setupLibPathsPage();
		void setupDepsPage();
		void setupBuildOrderPage();
		void setupCompilerPage();
		void setupLocationsPage();
		void setupCorbaPage();

	public slots:
		virtual void slotDefault();
		virtual void slotOk();
		virtual void slotApply();
	private slots:
		void applyToConfig();
		void updateControls( );

	private:
		TPConfigBasicPage 		*myBasicPage;
		TPConfigBuildModePage 	*myBuildModePage;
		TPConfigIncludePage 		*myIncludePage;
		TPConfigLibsPage 			*myLibsPage;
		TPConfigLibPathsPage 		*myLibPathsPage;
		TPConfigDepsPage 		*myDepsPage;
		TPConfigBuildOrderPage 	*myBuildOrderPage;
		TPConfigCompilerPage 		*myCompilerPage;
		TPConfigLocationsPage 		*myLocationsPage;
		TPConfigCorbaPage 		*myCorbaPage;

		TrollProjectItem* myPrj;
};

#endif
