/***************************************************************************
 *   Copyright (C) 2004 by Thomas Hasart
 *   thasart@gmx.de
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version
 *
 ***************************************************************************/


#include "tpconfiglibpathspage.h"
#include "tpoutsidelistview.h"
#include "tpconfigdialog.h"
#include <kdebug.h>
#include <qlayout.h>
#include <kurlrequesterdlg.h> 
#include <kurlrequester.h> 
#include <kfile.h> 

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigLibPathsPage::TPConfigLibPathsPage( TPConfigDialog *aDlg, QWidget * parent, const char * name, WFlags fl )
		: TPOutsideListView(parent,name,fl)
{
	//delete(myInsideLayout);
	myDialog=aDlg;
	slotUpdateControls();
	//connect(myConf,SIGNAL(applyToConfig()),this,SLOT(applyToConfig()));
}

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigLibPathsPage::~TPConfigLibPathsPage()
{
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigLibPathsPage::slotEdit()
{
    QListViewItem *item=myListView->currentItem();
    if(item==NULL)return;
    QString text=item->text(0);

    KURLRequesterDlg dialog(text, i18n("Change library directory:"), 0, 0);
    dialog.urlRequester()->setMode(KFile::Directory);
    if (dialog.exec() != QDialog::Accepted)
        return;
    QString dir = dialog.urlRequester()->url();
    if (!dir.isEmpty())
        item->setText(0,dir);

}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigLibPathsPage::slotAdd()
{
    KURLRequesterDlg dialog("", i18n("Add library directory:"), 0, 0);
    dialog.urlRequester()->setMode(KFile::Directory);
    if (dialog.exec() != QDialog::Accepted)
        return;
    QString dir = dialog.urlRequester()->url();
    if (!dir.isEmpty())
        new QListViewItem(myListView, dir);

}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigLibPathsPage::slotUpdateControls( )
{
	listView()->clear();
	//update librarys
	//temp strlist
	QStringList libDirList=myDialog->project()->configuration.m_librarypath;

	QPtrList <TrollProjectItem> itemList=myDialog->project()->getAllProjects();
	myListView->setSorting(-1,false);

	TrollProjectItem *item=itemList.first();

	while(item)
	{
		if(item->type()==TrollBaseItem::Subproject)
		{

			//librarys
			if( item->configuration.m_template==QTMP_LIBRARY )
			{
				TrollProjectItem *sItem=item;

				if(sItem!=myDialog->project())
				{
					// create lib string
					QString tmpLibDir=sItem->getLibAddPath(myDialog->project()->getDownDirs());

					QStringList::Iterator it=libDirList.begin();
					for(;it!=libDirList.end();++it)
					{

						if((*it).find(tmpLibDir)>=0 && tmpLibDir!="" && !tmpLibDir.isEmpty())
						{
							libDirList.remove(it);
							it=libDirList.begin();
						}
					}
				}
			}
		}
		item=itemList.next();
	}

	//all other in libList are outside libs
	QStringList::Iterator it1=libDirList.begin();
	for(;it1!=libDirList.end();++it1)
	{
		new QListViewItem(myListView,myListView->lastItem(),(*it1));
	}


}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigLibPathsPage::applyToConfig( )
{
	//extra lib paths
	QListViewItem *lvItem=listView()->firstChild();
	while(lvItem)
	{
		myDialog->project()->configuration.m_librarypath.append(lvItem->text(0));
		lvItem=lvItem->itemBelow();
	}
}



#include "tpconfiglibpathspage.moc"

