/***************************************************************************
 *   Copyright (C) 2004 by Thomas Hasart
 *   thasart@gmx.de
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version
 *
 ***************************************************************************/


#include "tpconfiglocationspage.h"
#include "tpconfigdialog.h"
#include <kurlrequester.h>
#include <kfile.h>


//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigLocationsPage::TPConfigLocationsPage( TPConfigDialog *aDlg, QWidget * parent, const char * name, WFlags fl )
		: TPConfigLocationsPageBase(parent,name,fl)
{
	//delete(myInsideLayout);
	myDialog=aDlg;
	slotUpdateControls();
	myObjUrl->setMode(KFile::Directory);
	myUiUrl->setMode(KFile::Directory);
	myMocUrl->setMode(KFile::Directory);
	
	//connect(myConf,SIGNAL(applyToConfig()),this,SLOT(applyToConfig()));
}

//------------------------------------------------------------------------------------------------------------------------------------------
TPConfigLocationsPage::~TPConfigLocationsPage()
{
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigLocationsPage::slotUpdateControls( )
{
	myObjUrl->setURL(myDialog->project()->configuration.m_objectpath);
	myUiUrl->setURL(myDialog->project()->configuration.m_uipath);
	myMocUrl->setURL(myDialog->project()->configuration.m_mocpath);
}

//------------------------------------------------------------------------------------------------------------------------------------------
void TPConfigLocationsPage::applyToConfig( )
{
	myDialog->project()->configuration.m_objectpath=myObjUrl->url();
	myDialog->project()->configuration.m_uipath=myUiUrl->url();
	myDialog->project()->configuration.m_mocpath=myMocUrl->url();
}

/*$SPECIALIZATION$*/


#include "tpconfiglocationspage.moc"

